#ifndef COMPONENTLIB_IDS_H
#define COMPONENTLIB_IDS_H

// Component Id constants
namespace {
 const MicroFlo::ComponentId IdForward = 1;
 const MicroFlo::ComponentId IdDigitalWrite = 2;
 const MicroFlo::ComponentId IdToggleBoolean = 3;
 const MicroFlo::ComponentId IdTimer = 4;
 const MicroFlo::ComponentId IdSplit = 5;
};

#endif // COMPONENTLIB_IDS_H
#ifndef COMPONENTLIB_PORTS_H
#define COMPONENTLIB_PORTS_H


namespace ForwardPorts {
struct InPorts {
enum Ports {
    in = 0
};
};
struct OutPorts {
enum Ports {
    out = 0
};
};
}

namespace DigitalWritePorts {
struct InPorts {
enum Ports {
    in = 0,
    pin = 1
};
};
struct OutPorts {
enum Ports {
    out = 0
};
};
}

namespace ToggleBooleanPorts {
struct InPorts {
enum Ports {
    in = 0,
    reset = 1
};
};
struct OutPorts {
enum Ports {
    out = 0
};
};
}

namespace TimerPorts {
struct InPorts {
enum Ports {
    interval = 0,
    reset = 1
};
};
struct OutPorts {
enum Ports {
    out = 0
};
};
}

namespace SplitPorts {
struct InPorts {
enum Ports {
    in = 0
};
};
struct OutPorts {
enum Ports {
    out1 = 0,
    out2 = 1,
    out3 = 2,
    out4 = 3,
    out5 = 4,
    out6 = 5,
    out7 = 6,
    out8 = 7,
    out9 = 8
};
};
}

#endif // COMPONENTLIB_PORTS_H
#include "/Users/tommyjtl/Documents/code/playground/microflo/test/components/Forward.hpp"
#include "/Users/tommyjtl/Documents/code/playground/microflo/test/components/DigitalWrite.hpp"
#include "/Users/tommyjtl/Documents/code/playground/microflo/test/components/ToggleBoolean.hpp"
#include "/Users/tommyjtl/Documents/code/playground/microflo/test/components/Timer.hpp"
#include "/Users/tommyjtl/Documents/code/playground/microflo/test/components/Split.hpp"


// Component factory functionality
Component *createComponent(MicroFlo::ComponentId id) {
    Component *c;
    switch (id) {
    case IdForward: c = new ::Forward; c->setComponentId(id); return c;
    case IdDigitalWrite: c = new ::DigitalWrite; c->setComponentId(id); return c;
    case IdToggleBoolean: c = new ::ToggleBoolean; c->setComponentId(id); return c;
    case IdTimer: c = new ::Timer; c->setComponentId(id); return c;
    case IdSplit: c = new ::Split; c->setComponentId(id); return c;
    default: return NULL;
    }}